<id>
WhoReg YaBB2
</id>

<version>
1.2a
</version>

<mod info>
This mod allows only an admin to define what email addresses a user can register with allowing him/her the power of who can register.  This also affects the "Add New Member" function in the Admin Center.  The email addresses are added in the admin center.  If the box is blank, any registrant can use any email address.


Compatability
--------------
YaBB 2 only


Installation
----------------------------
1)  Mod the finals (Admin.pl, AdminSubList.pl, AdminIndex.pl, ModList.pl & Register.pl) and upload in ASCII
2)  Upload in ASCII woreg.lng to the language folder.
3)  In the Admin center, use the option to send a random password or pre-registration, so that even if someone spoofs a registrant the email owneer will know it.


Version History
----------------------
1.0 Initial Release
1.2a Update for Y2 Final Release
</mod info>

<author>
astro-pilot
</author>

<homepage>

</homepage>

<edit file>
Admin/Admin.pl
</edit file>

<search for>
	fopen(FILE, ">$vardir/ban.txt", 1);
	print FILE "I|$FORM{'ban'}\n";
	print FILE "E|$FORM{'ban_email'}\n";
	print FILE "U|$FORM{'ban_memname'}\n";
	fclose(FILE);
	$yySetLocation = qq~$adminurl~;
	&redirectexit;
}

</search for>

<add after>
### Who Reg mod ###
sub whoreg {  
	LoadLanguage("whoreg");
	&is_admin_or_gmod;
	my(@ae);
	fopen(FILE, "$vardir/whoreg.txt");
	@ae = <FILE>;
	fclose(FILE);
	@ae = sort @ae;
$yymain .= qq~	
<form action="$adminurl?action=whoreg2" method="post">
 <div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
       <td align="left" class="titlebg">
<img src="$imagesdir/guest.gif" alt="" border="0" /> <b>$whoreg_txt{'3'}</b>
	   </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="catbg"><span class="small">
			$whoreg_txt{'4'}
		 </span>
	   </td>
     </tr>
     <tr valign="middle">
       <td align="center" class="windowbg2"><br />
		<textarea cols="60" rows="10" name="ea" style="width: 95%">~;
	foreach $oke (@ae) {
		chomp $oke;
		if( $oke =~ m~\A\s+\Z~  ) { next; }
		$yymain .= "$oke\n";
	}
	$yymain .= qq~</textarea><br /><br />
	   </td>
     </tr>
     <tr valign="middle">
     	<td align="center" class="catbg">
		<input type="submit" value="$admin_txt{'10'}" />
	</td>
     </tr>
   </table>
 </div>
</form>
~;
	$yytitle = "$admin_txt{'340'}";
	$action_area = "whoreg ";
	&AdminTemplate;
	exit;
}

sub whoreg2 {
	&is_admin_or_gmod;
	$FORM{'ea'} =~ tr/\r//d;
	$FORM{'ea'} =~ s~\A[\s\n]+~~;
	$FORM{'ea'} =~ s~[\s\n]+\Z~~;
	$FORM{'ea'} =~ s~\n\s*\n~\n~g;
	fopen(FILE, ">$vardir/whoreg.txt", 1);
	print FILE "$FORM{'ea'}";
	fclose(FILE);
	$yySetLocation = qq~$adminurl~;
	&redirectexit;
}  ### Who Reg mod end ###

</add after>

<search for>
	&admin_fatal_error("($member{'username'}) $register_txt{'76'}")                     if ($member{'email'} eq "");
	&admin_fatal_error("($member{'username'}) $register_txt{'100'}")                    if (-e ("$memberdir/$member{'username'}.vars"));
	&admin_fatal_error("$register_txt{'1'}")                                            if ($member{'username'} eq $member{'passwrd1'});
</search for>

<add after>

	###Who Registers mod ###
	LoadLanguage("whoreg");
	my $found;
	my $r = 0;
	my $mem_mail = $member{email};
	open USERIDS, "$vardir/whoreg.txt" || die $!;
	while( <USERIDS>) {
      		chomp $_;
      		if ($_ =~ m/$mem_mail/){$found = 1; last;}
      		$r++;
         	}
	close USERIDS;
	&admin_fatal_error("$whoreg_txt{'5'}") unless ($found || $r eq "0");
	###Who Registers end ###

</add after>

<edit file>
AdminIndex.pl
</edit file>

<search for>
require "$vardir/advsettings.txt";
require "$vardir/secsettings.txt";
require "$vardir/membergroups.txt";
</search for>

<add after>
LoadLanguage("whoreg");  ### Who Reg mod ###
</add after>

<search for>
	@member_controls = ("|$admintxt{'a6_title'}|$admintxt{'a6_label'} - $admintxt{'34'}|a6", "addmember|$admintxt{'a6_sub1'}|$admintxt{'a6_label1'}|", "viewmembers|$admintxt{'a6_sub2'}|$admintxt{'a6_label2'}|", "modmemgr|$admintxt{'a6_sub3'}|$admintxt{'a6_label3'}|", "mailing|$admintxt{'a6_sub4'}|$admintxt{'a6_label4'}|", "ipban|$admintxt{'a6_sub5'}|$admintxt{'a6_label5'}|", "setreserve|$admintxt{'a6_sub6'}|$admintxt{'a6_label6'}|",);
</search for>

<add after>
	push (@member_controls, "whoreg|$whoreg_txt{'1'}|$$whoreg_txt{'1'}|"); ### Whoreg mod ###
</add after>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'ipban',"Admin.pl&ipban",
'ipban2',"Admin.pl&ipban2",
</search for>

<add after>
'whoreg',"Admin.pl&whoreg",   ### Who Reg mod ###
'whoreg2',"Admin.pl&whoreg2",  ### Who Reg mod ###
</add after>

<edit file>
Sources/Register.pl
</edit file>

<search for>
	&fatal_error("($member{'username'}) $register_txt{'76'}")                     if ($member{'email'} eq "");
	&fatal_error("($member{'username'}) $register_txt{'100'}")                    if (-e ("$memberdir/$member{'username'}.vars"));
	&fatal_error("$register_txt{'1'}")                                            if ($member{'username'} eq $member{'passwrd1'});

</search for>

<add after>
	### Who Registers mod ###
	LoadLanguage("whoreg");
	my $found;
	my $r = 0;
	my $mem_mail = $member{email};
	open USERIDS, "$vardir/whoreg.txt" || die $!;
	while( <USERIDS>) {
      		chomp $_;
      		if ($_ =~ m/$mem_mail/){$found = 1; last;}
      		$r++;
         	}
	close USERIDS;
	&fatal_error("$whoreg_txt{'2'}") unless ($found || $r eq "0");
	###Who Registers mod end ###

</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add after>
	$whoreg_mod = qq~WhoReg_YaBB2|astro-pilot|This mod allows only an admin to define what email addresses a user can register with allowing him/her the power of who can register.  This also affects the "Add New Member" function in the Admin Center.  The email addresses are added in the admin center.  If the box is blank, any registrant can use any email address.|1.2a|9/30/05~;
	push (@installed_mods, "$whoreg_mod");
</add after>